;
; Script Name:    Network Time Server Set
; Version:        1.0.1
; Language:       English
; Platform:       Win2K/XP
; Author:         Sysop Scripts
;
; Script Function:
;	Sets the local computer network time server and starts the w32time service automatically.
;

#NoEnv ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input ; Recommended for new scripts due to its superior speed and reliability.
#SingleInstance force ;Only one instance of script at a time
#NoTrayIcon ;Removes tray icon display

;Determine if current user has administrator rights before running
If A_IsAdmin = 1
    Goto, IsAdmin
Else
{
    MsgBox, 16, Oops!, You must have administrator rights to run this script!
    ExitApp
}

IsAdmin:
Sleep, 100

;Build GUI interface
Gui, Add, ComboBox, x16 y37 w330 h10 vNtps, time.nist.gov || pool.ntp.org | time.windows.com
Gui, Add, Button, x246 y77 w100 h30 gCancel, &Cancel
Gui, Add, Button, x16 y77 w160 h30 gSubmit, &Submit
Gui, Add, Text, x16 y17 w330 h20 , Enter or Select NTP Server (DNS or IP):
Gui, Add, Text, x16 y117 w330 h20 +Center, Win2K/XP - Sysop Scripts
; Generated using SmartGUI Creator 4.0
Gui, Show, x131 y91 h158 w366, Network Time Server Set v1.0.1
Return

;Submits ComboBox data to be processed and change time server settings
Submit:
Gui, Submit, NoHide

MsgBox, 4,Network Time Server Set, Are you sure you wish to change the network time server to %Ntps%?
IfMsgBox Yes
{
    ;Stop network time service
    Progress, 25, Stopping service (if active), Processing...,Network Time Server Set
    RunWait, net stop w32time, ,Hide
    ;Change NTP registry settings
    Progress, 50, Changing settings..., Processing...,Network Time Server Set
    RegWrite, REG_DWORD, HKEY_LOCAL_MACHINE, SYSTEM\CurrentControlSet\Services\W32Time, Start, 2
    RegWrite, REG_SZ, HKEY_LOCAL_MACHINE, SYSTEM\CurrentControlSet\Services\W32Time\Parameters, NtpServer, %Ntps%
    Sleep, 2000
    ;Restart network time service
    Progress, 75, (Re)starting service..., Processing...,Network Time Server Set
    RunWait, net start w32time, ,Hide
    Progress, 100, Completed, Processing...,Network Time Server Set
    Sleep, 1000
    Progress, Off
    MsgBox, 0, Success, Network Time Server has been changed/updated, and the time service automatically started.
    ExitApp
}
else

    Return
    

Cancel:
ExitApp

GuiClose:
ExitApp